package cn.com.ctop.shiwan.modules.service.impl;

import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.common.module.utils.CosUtils;
import cn.com.ctop.common.module.vo.ResFileDTO;
import cn.com.ctop.shiwan.modules.entity.ShiwanFileUpload;
import cn.com.ctop.shiwan.modules.mapper.ShiwanFileUploadMapper;
import cn.com.ctop.shiwan.modules.service.IShiwanFileUploadService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.xxl.job.core.enums.NoEn;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import java.util.Date;

/**
 * 试玩平台，文件信息
 * try-play
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-10-21
 */
@Service
public class ShiwanFileUploadServiceImpl extends ServiceImpl<ShiwanFileUploadMapper, ShiwanFileUpload> implements IShiwanFileUploadService {

    @Autowired
    private ShiwanFileUploadMapper shiwanFileUploadMapper;


    @Override
    public String fileSave(MultipartFile file, String w_userid, String fileId) {
        ResFileDTO resultFile = CosUtils.uploadMultipartFile(file, "try-play/zip/");
        if (Check.isNull(resultFile)) {
            return null;
        }
        ShiwanFileUpload fileUpload = new ShiwanFileUpload();
        fileUpload.setCfileName(resultFile.getCFileName());
        String filename = file.getOriginalFilename();
        fileUpload.setFileName(filename);
        String fileSuffix = filename.substring(filename.lastIndexOf(".") + 1).toLowerCase();
        fileUpload.setFileSuffix(fileSuffix);
        fileUpload.setFileName(file.getOriginalFilename());
        if ("zip".equals(fileSuffix)) {
            fileUpload.setFileLevel(NoEn.NO0.valueInt());
        } else {
            fileUpload.setFileLevel(NoEn.NO1.valueInt());
        }
        fileUpload.setFileStatus(NoEn.NO1.valueStr());

        fileUpload.setFileSize(Math.random() + "kb");
        fileUpload.setFileUrl(resultFile.getFileUrl());
        fileUpload.setUploadTime(new Date());
        //TODO
        fileUpload.setUserId(null);
        fileUpload.setFileType(null);
        fileUpload.setFunctionType(null);
        shiwanFileUploadMapper.insert(fileUpload);
        return resultFile.getFileUrl();
    }
}
